// Data: 30/03/2021  2 Semestre de 2020.
// Prof. Dr. Jean M. Simo - DAINF/UTFPR Curitiba-Central.

// UNIVERSIDADE TECNOLGICA FEDERAL DO PARAN - Campus de Curitiba Central 
// Dep. Acadmico de Informtica (DAINF). Disciplina: Tcnicas de Programao  CSE20.
// Prova sobre linguagem C++ / Diagrama de Classes (UML) / Orientao a Objetos  Prova 1 Parcial

// Nome do(a) Discente: __________________________________________________ Turma: S73
// Curso: _____ .__________ Horrio de Comeo: ____________ Horrio de Fim: _____________

// Leia toda a prova, pois os enunciados esto completados uns nos outros.
// Utilize os bons princpios de projeto e programao orientada a objetos.
// Em tempo, questes de mesmo peso, idem para os tpicos dentro delas (quando houver).

// A interpretao faz parte do contedo da prova! Inclua comentrios (se for o caso) para deixar explicitas suas decises.  Pgina 1/1.


#include <iostream>
#include <vector>
#include <list>
using namespace std;

#define LIMITE 1000
#define MAX_T  3

// (Questo - 1)
class Ente
{
    protected:
        static unsigned long int conta_tempo;
        static unsigned long int max_tempo;
        short int cont_aux;

        bool eh_pessoa; // atributo de auxlio

    public:

        Ente() :
            cont_aux(0)
        {
        }

        virtual ~Ente()
        {
        }

        // static void setMaxTempo(unsigned long int maxi)    { max_tempo = maxi;  }
        virtual void operator++() = 0;

        const bool getEhPessoa() const { return eh_pessoa; }
};

unsigned long int Ente::conta_tempo = 0;
unsigned long int Ente::max_tempo = MAX_T;

// (Questo - 2)

class Virus : public Ente
{
    private:
        short int resistencia;

    public:
        Virus(short int r = 10):
        Ente(),
        resistencia(r)
        {
            eh_pessoa = false;
        }

        ~Virus()
        {
        }

        void setResistencia(const short int r) { resistencia = r; }
        const short int getResistencia () const { return resistencia; }

        void operator++()
        {
            if (cont_aux >= 500)
            {
                resistencia += 10;
                cont_aux = 0;
            }
            else
            {
                cont_aux++;
            }
        }
};

// (Questo - 3)

class Anticorpo : public Ente
{
private:
    short int forca;  // fora

public:
    Anticorpo():
    Ente(),
    forca(5)
    {
        eh_pessoa = false;
    }

    ~Anticorpo()
    {
    }

    void operator++()
    {
        if (cont_aux >= 50)
        {
            forca++;
            cont_aux = 0;
        }
        else
        {
            cont_aux++;
        }
    }

    void contraataca(Virus* pv)
    {
        if (pv != NULL)
        {
            pv->setResistencia(pv->getResistencia()-forca);
        }
    }
};

// (Questo - 4)

class Pessoa : public Ente
{
    private:
        vector<Virus*> carga_viral;
        vector<Anticorpo*> sistema_defesa;

        bool imunizado;

    public:
        Pessoa(const bool i = false) :
        Ente(),
        imunizado(i)
        {
            eh_pessoa = true;
        }

        ~Pessoa()
        {
            carga_viral.clear();
            sistema_defesa.clear();
        }

        void contaminarse(Virus* pV)
        {
            if (pV != NULL)
            {
               carga_viral.push_back(pV);
            }
        }

        void ter_anticorpo(Anticorpo* pA)
        {
            if (pA)
            {
                sistema_defesa.push_back(pA);
            }
        }

        void operator++()
        {
            if (imunizado)
            {
                for (long int i = 0; i < sistema_defesa.size(); i++ )
                {
                    Anticorpo* pA = NULL;
                    pA = sistema_defesa[i];

                    for (long int j = 0; j < carga_viral.size(); j++ )
                    {
                        Virus* pV = NULL;
                        pV = carga_viral[j];
                        if (pV)
                        {
                            pA->contraataca(pV);
                        }
                        else
                        {
                            cout << "Ponteiro para virus nulo" << endl;
                        }
                    }
                }
            }
            else
            {
                //imunizado = (conta_tempo > LIMITE);

                if ( conta_tempo > LIMITE )
                {
                    imunizado = true;
                }
            }
        }

        const bool curado() const
        {
            return carga_viral.size() ? false : true;

            //return !carga_viral.size();
        }
};

// (Questo - 5)

class Sociedade : public Ente
{
    private:
        long int num_pessoas;
        long int num_imunizados;

        list<Ente*> conj_entes;
        list<Ente*>::const_iterator it;

    public:

    Sociedade(const long int np = 0, const long int ni = 0) :
        Ente (),
        conj_entes(),
        it(),
        num_pessoas(np),
        num_imunizados(ni)
    {
        if (num_imunizados > num_pessoas) { num_imunizados = num_pessoas; } // apenas para validacao.

        Pessoa* pP = NULL;

        long int x = -1;
        long int y = -1;
        long int z = -1;

        long int num_carga_viral = -1;

        x = (long int) ( num_pessoas - (num_imunizados/2) );

        num_carga_viral = (long int) ( ( 1 * x ) / 100 );

        y = (long int) x / 4;

        z = (long int) 2 * x;

        for (long int i = 0; i < num_pessoas; i++)
        {
            long int temp = -1;

            if (i < num_imunizados)
            {
                pP = new Pessoa(true);
                temp = z;
            }
            else
            {
                pP = new Pessoa(false);
                temp = y;
            }

            conj_entes.push_back(static_cast<Ente*>(pP));

            for (long int i = 0; i < num_carga_viral; i++)
            {
                Virus* pV = NULL;
                pV = new Virus();
                pP->contaminarse(pV);

                conj_entes.push_back(static_cast<Ente*>(pV));
            }

            for (long int i = 0; i < temp; i++)
            {
                Anticorpo* pA = NULL;
                pA = new Anticorpo();
                pP->ter_anticorpo(pA);

                conj_entes.push_back(static_cast<Ente*>(pA));
            }
        }

        conj_entes.push_back(static_cast<Ente*>(this));

        max_tempo = MAX_T;

        cout << "TUDO CRIADO!" << endl;
    }

    ~Sociedade()
    {
        Ente* paux = NULL;

        conj_entes.pop_back();

        it = conj_entes.begin();

        while (it != conj_entes.end())
        {
            paux = *it;
            if (paux != NULL)
            {
                delete paux;
            }
            paux = NULL;
            it++;
        }

        conj_entes.clear();
    }

    void executar()
    {
        int curados = 0;
        int contaminados = 0;

        for (int i = 0; i < max_tempo; i++)
        {
            Ente* paux = NULL;

            it = conj_entes.begin();

            while ( it != conj_entes.end() )
            {
                paux = *it;
                if (paux != NULL)
                {
                    paux->operator++();
                }
                paux = NULL;
                it++;
            }
        }


        it = conj_entes.begin();

        long int tam = (long int) conj_entes.size();

        for ( long int k = 0; k < tam; k++)
        {
            if ( (*it)->getEhPessoa() )
            {

                Pessoa* pP = NULL;

                pP = (Pessoa*)*it;

                if (pP->curado())
                {
                    curados++;
                }
                else
                {
                    contaminados++;
                }
            }

            it++;
        }

        cout << endl;
        cout << "Nesta sociedade o nmero de pessoas circulando foi de: " << num_pessoas << " , sendo inicialmente " << num_imunizados << " imunizados." << endl;
        cout << "Assim, tem-se neste momento o que segue: " << endl;
        cout << "- Nao contaminados: " << curados << endl;
        cout << "- Contaminados: " << contaminados << endl;
        cout << endl;
    }

    void operator++()
    {
        conta_tempo++;
    }
};

int main()
{
    Sociedade sociedade1 (1000, 200);
    sociedade1.executar();

    Sociedade sociedade2 (5000, 1000);
    sociedade2.executar();

    Sociedade sociedade3 (10000, 3000);
    sociedade3.executar();

    // ATENO: Em alguns ambientes que restrigem memria,  necessrio desabilitar o limite do uso de recursos de memria.
    // Nestes casos, no desabilitando, pode ocorrer erros de execuo, cf. bem observou o aluno Eduardo S. dos Santos no segundo semestre de 2021.

    // Alternativamente, pode-se tambm testar as sociedades com valores bem menores.

    return 0;
}

